<?php
/**
 * Utilidades comunes a toda la aplicación: 
 * 	- Base de datos
 *  - Manejador de errores
 *  - JSON para compatibilidad en versiones previas de PHP
 * Este archivo debe incluirse en la cabecera del resto de los archivos de la aplicación.
 * 
 * Copyright (C) 2013 Pablo Taboada <pablo[dot]taboada[at]gmail[dot]com>
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

/**
 * Devuelve una conexión válida con la base de datos, estableciendo los parámetros de la conexión.
 * Permite unificar en un único punto los parámetros de conexión, permitiendo cambiarlos sin tener
 * que tocar el resto del código.
 */
function conectaBBDD(){		
	$base = 'tamhome'; 
	$user = 'android';
	$clave = 'UOC2013';
	$server = 'android.tamtamhome.com';
		
	$conn = mysql_connect($server, $user, $clave);
	if(!$conn){
		die('No se pudo conectar: '. mysql_error());
	}
	mysql_select_db($base, $conn);

	return $conn;
}

/**
 * Recibiendo como parámetro una consulta SQL SELECT, devuelve una tabla de dos dimensiones con los 
 * registros solicitados en la consulta.
 * Si la consulta no obtiene resultado, devuelve FALSE.
 * 
 * @param $sql 		String con la consulta SQL SELECT a ejecutar
 * @return 			Tabla bidimensional con tantas filas como registros y tantas columnas como
 * 						 campos tenga la consulta, o FALSE si la consulta no obtiene resultados.
 */
function pideDatos($sql){
	$conexion = conectaBBDD(); 
	
	$res = mysql_query($sql, $conexion);
	if(!$res){
		die("ERROR SQL: ". mysql_error() ." \n CONSULTA: $sql ");
	}

	if(mysql_num_rows($res)>0){
		$tbl = array();
		while($fila=mysql_fetch_assoc($res)){
			$tbl[] = $fila;
		}
		return $tbl;
	}else{
		return false;
	}
	mysql_free_result($res);
	mysql_close($conexion);
}

/**
 * Lanza una consulta SQL de actualización (INSERT, DELETE o UPDATE) contra la base de datos
 * y obtiene el número de registros afectados por la misma.
 * 
 * El resultado será 0 si no hay registros afectados o si falla la consulta.
 * 
 * @param $sql 	String con la consulta SQL de actualización a ejecutar.
 * @return 		Número de registros afectados por la consulta.
 */
function guardaDatos($sql){
	$conexion = conectaBBDD();

	if(!mysql_query($sql, $conexion)){
		return 0;
	}else{
		$filasAfectadas=mysql_affected_rows();
		return $filasAfectadas;
	}
	mysql_close($conexion);
}

/**
 * Manejador de errores para toda la aplicación. Facilita la gestión centralizada de todos los errores PHP.
 * En este caso se permite el mostrado de errores por pantalla. Se recomienda el envío de errores por mail
 * para entornos de producción
 * 
 * @param $level 	Nivel de error
 * @param $message 	Mensaje descriptivo del error
 * @param $file 	Archivo en el que se genera el error
 * @param $line 	Línea del archivo en el que se genera el error
 */
function erros($level, $message, $file, $line){
	define("DESTINO",0);
	define("FATAL",true);
	
	$e = " ERROR $level: $message \n ARCHIVO: $file \n LINEA: $line \n\n";
	error_log($e, DESTINO);
	if(FATAL){
	 	die($e);
	}
}

// Establece el manejador definido en lugar del manejador por defecto:
set_error_handler("erros");

/* 
 * JSON para PHP<5.2 (en versione superiores ya están integradas en PHP)
 * El código correspondiente no es de mi autoría, tal y como se recoge en el encabezado del archivo incluido.
 */
if(!function_exists('json_encode')) { 
	function json_encode($content) {
		require_once('json.php');
		$json = new Services_JSON;
		return $json->encode($content);
	}
}
?>
