<?php
/**
 * Entrega de datos de TamTam-Home pedidos por el cliente Android.
 * 
 * Tras una primera validación del token de sesión (para obtener el idContrato afectado)
 * se entregan los datos de Centros (c), Empleados (e) o Turnos (t) solicitados.
 * 
 * Si hay algún problema con la consulta o no hay resultados a la misma, 
 * se responde con un JSON con con "res:KO" junto con el motivo en el campo "val".
 * Si hay resultados se entregan en formato JSON.
 * 
 * 
 * Copyright (C) 2013 Pablo Taboada <pablo[dot]taboada[at]gmail[dot]com>
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

require_once('inc/datos.php');

$idContrato = 0; // El id del contrato del cual se obtendrán los resultados

// VALIDACIÓN DEL TOKEN:
if ( isset($_GET['t']) ) {
	$token = addslashes(substr($_GET['t'],0,32));
	
	$vc = pideDatos("SELECT id,idContrato,current_date hoy FROM usuarios WHERE MD5(CONCAT(id,current_date))='$token';");

	if($vc){
		$idContrato = $vc[0]['idContrato'];
	}else{
		echo('[{"res":"KO","val":"TOKEN_ERR"}]');
		exit();
	}
}else{
	echo('[{"res":"KO","val":"NO_TOKEN"}]');
	exit();
}

// OBTENCIÓN DE RESULTADOS:
if ( isset($_GET['tbl']) && $idContrato!=0 ) {
	$sql = "";
	switch($_GET['tbl']){
		case "c": // Centros
			$sql = "SELECT c.id, c.nombre nom, c.direccion dir, c.cp, po.poblacion pob, pr.provincia pro  
						FROM (centros c INNER JOIN poblaciones po ON c.idPoblacion=po.id)
						INNER JOIN provincias pr ON po.idProvincia=pr.id  
						WHERE c.idContrato=$idContrato 
						ORDER BY nom;";
			break;
		case "e": // Empleados
			$sql = "SELECT id, nombre nom, telefono tel, codigo cod 
						FROM empleados 
						WHERE idContrato=$idContrato 
						ORDER BY nom;";
			break;
		case "t": // Turnos
			$sql = "SELECT t.id, c.nombre ofi, e.nombre emp, t.entrada ini, t.salida fin, t.idEstado ok 
						FROM (turnos t INNER JOIN centros c ON t.idCentro=c.id)
						INNER JOIN empleados e ON t.idEmpleado=e.id  
						WHERE c.idContrato=$idContrato AND e.idContrato=$idContrato  
						ORDER BY ini DESC 
						LIMIT 15;";
			break;
	}
	if($sql!=""){
		$datos = pideDatos($sql);
		if($datos){
			echo json_encode($datos);
		}else{
			echo '[{"res":"KO","val":"0"}]';
		}
	}else{
		echo('[{"res":"KO","val":"NO_TBL"}]');
	}
}else{
	echo('[{"res":"KO","val":"NO_TBL"}]');
}
?>
