<?php
/**
 * Validación de usuario para el acceso a datos de TamTam-Home:
 * Permite la validación del token de sesión (parámetro "t" recibido por GET)
 * o la validación de nombre de usuario y contraseña (parámetros "u" y "c" recibidos por GET)
 * 
 * Todas las respuestas son en formato JSON, con:
 *  - res:OK si la validación es correcta
 *  - res:KO si la validación es incorrecta
 * junto con un campo "val" con los detalles de la validación.
 * 
 * Copyright (C) 2013 Pablo Taboada <pablo[dot]taboada[at]gmail[dot]com>
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

require_once('inc/datos.php');

if ( isset($_GET['t']) ) {
	// Nos llega el token: verificamos que sea válido:
	$token = addslashes(substr($_GET['t'],0,32));
	
	$vc = pideDatos("SELECT id,current_date hoy FROM usuarios WHERE MD5(CONCAT(id,current_date))='$token';");
	if($vc){
		echo('[{"res":"OK","val":"'.$token.'"}]');	// token válido
	}else{
		echo('[{"res":"KO","val":"TOKEN_ERR"}]');	// token incorrecto
	}
	
} elseif ( isset($_GET['u']) && isset($_GET['c']) ) {
	// Nos llegan usuario y clave: verificamos si son válidas:
	$usuario = addslashes(substr($_GET['u'],0,50));
	$clave = addslashes(substr($_GET['c'],0,50));

	$vc = pideDatos("SELECT id,clave,current_date hoy FROM usuarios WHERE usuario='$usuario';");
	if($vc){
		$v = $vc[0];
		if($v['clave']==sha1('peixe'.$clave)){
			guardaDatos("UPDATE usuarios SET token=MD5(CONCAT(id,current_date)) WHERE id=$v[id];");
			echo('[{"res":"OK","val":"'. md5($v['id'].$v['hoy']) .'"}]');
		}else{
			echo('[{"res":"KO","val":"USER_ERR"}]');
		}
	}else{
		echo('[{"res":"KO","val":"USER_ERR"}]');
	}
        
}else{
	// NO llega ni TOKEN ni USUARIO+CLAVE: devolvemos error
	echo('[{"res":"KO","val":"NO_USER"}]');
}
?>
